﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ScrumViewer.Models;
using ScrumViewer.Pages.LogIn;
using ScrumViewer.Services;

namespace ScrumViewer.Models
{
    public class StoryBoard
    {
        //private static int nextStoryId = 1;
        public int ProjectNo { get; set; }
        public string ProjectName { get; set; }
        public string ProductOwner { get; set; }
        public string ScrumMaster { get; set; }
        public List<TeamMember> TeamMembers { get; set; }
        //public StoryState ProductBacklog { get; set; }
        //public StoryState ToDo { get; set; }
        //public StoryState Doing { get; set; }
        //public StoryState Done { get; set; }
        //public StoryState DoneDone { get; set; }

        public List<Card> Cards { get; set; }

        public Sprint CurrentSprint { get; set; }
        //private static int SprintNo = 3;

        private CardNoGeneratorService cardNoGeneratorService;

        public StoryBoard(CardNoGeneratorService cardNoGeneratorService)
        {
            this.cardNoGeneratorService = cardNoGeneratorService;
            Cards = new List<Card>();
            CurrentSprint = new Sprint(3, 5, "icon-sprint3");
            //DoneDone = new StoryState(null,null, "DoneDone");
            //Done = new StoryState(null,DoneDone, "Done");
            //Doing = new StoryState(null,Done, "Doing");
            //ToDo = new StoryState(null, Doing, "ToDo"); 
            //ProductBacklog = new StoryState(null, ToDo, "ProductBacklog");
            //DoneDone.Previous = Done;
            //Done.Previous = Doing;
            //Doing.Previous = ToDo;
            //ToDo.Previous = ProductBacklog;
        }

        public void AddCard(Card card)
        {
            card.No = cardNoGeneratorService.GenerateCardNo(card);
            card.DateCreated=DateTime.Now;
            card.Sprint = CurrentSprint;
            //switch (SprintNo)
            //{
            //    case 0: story.SprintIcon = "icon-sprint1";
            //        break;
            //    case 1:
            //        story.SprintIcon = "icon-sprint1";
            //        break;
            //    case 2:
            //        story.SprintIcon = "icon-sprint2";
            //        break;
            //    case 3:
            //        story.SprintIcon = "icon-sprint3";
            //        break;
            //    case 4:
            //        story.SprintIcon = "icon-sprint4";
            //        break;

            //    default: story.SprintIcon = "icon-sprint1";
            //        break;
            //}

            //story.State = ProductBacklog;

            //ProductBacklog.AddStory(story);
            Cards.Add(card);
           
        }

        public bool MoveStory(Card story)
        {
            if (story.State <= 4)
            {
                story.State++;
                if (story.State == 2 && story is BacklogItem)
                {
                    story.Developer = (TeamMember)LoginPageModel.LoggedInUser;//new TeamMember(1, "Henrik H", "heho", "1234", "Developer", "img/heho.jpg"); //todo to be fixed
                    ((BacklogItem)story).DateTimeStarted = DateTime.Now;
                }
                return true;
            }
            return false;
        }

        public bool MoveBackStory(Card story)
        {
            if (story.State > 0)
            { 
                story.State--;
                if (story.State == 1) story.Developer = null;
                if (story.State == 2) story.Developer = (TeamMember)LoginPageModel.LoggedInUser;
                return true;
            }
            return false;
        }

        public void RedoStory(Card story)
        {
            if (story.State == 3)
                story.State = 0;
        }


        //public bool MoveStory(Card story)
        //{
        //    if (story.State.Next != null)
        //    {
        //        StoryState storyState = story.State;
        //        story.State.Next.AddStory(story);
        //        storyState.RemoveStory(story);
        //        return true;
        //    }
        //    return false;           
        //}

        //public bool MoveBackStory(Card story)
        //{
        //    if (story.State.Previous != null)
        //    {
        //        StoryState storyState = story.State;
        //        story.State.Previous.AddStory(story);
        //        storyState.RemoveStory(story);
        //        return true;
        //    }
        //    return false;
        //}



    }
}
