using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using ScrumViewer.Models;
using ScrumViewer.Services;

namespace ScrumViewer.Pages.LogIn
{
    public class LoginPageModel : PageModel
    {
        public static User LoggedInUser { get; set; } = null;

        private UserService _userService;
       
        public LoginPageModel(UserService userService)
        {
           _userService = userService;
        }

        [BindProperty]
        public string UserName { get; set; }
        [BindProperty, DataType(DataType.Password)]
        public string Password { get; set; }
        public string Message { get; set; }
        public async Task<IActionResult> OnPost()
        {
            List<TeamMember> users = _userService.Users;
            foreach ( User user in users)
            {
                if (UserName == user.Username && Password == user.Password)
                {
                    LoggedInUser = user;
                    var claims = new List<Claim>
                            {
                                new Claim(ClaimTypes.Name, UserName)
                            };
                    var claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
                    await HttpContext.SignInAsync(CookieAuthenticationDefaults.AuthenticationScheme, new ClaimsPrincipal(claimsIdentity));
                    return RedirectToPage("/ScrumBoard/index");
                }
            }
            //var user = configuration.GetSection("SiteUser").Get<SiteUser>();

            //if (UserName == user.UserName)
            //{
            //    var passwordHasher = new PasswordHasher<string>();
            //    if (passwordHasher.VerifyHashedPassword(null, user.Password, Password) == PasswordVerificationResult.Success)
            //    {
            //        var claims = new List<Claim>
            //        {
            //            new Claim(ClaimTypes.Name, UserName)
            //        };
            //        var claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
            //        await HttpContext.SignInAsync(CookieAuthenticationDefaults.AuthenticationScheme, new ClaimsPrincipal(claimsIdentity));
            //        return RedirectToPage("/admin/index");
            //    }
            //}
            Message = "Invalid attempt";
            return Page();
        }
    }
}
