using System;
using System.Collections.Generic;
using System.Linq;

using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ScrumViewer.Models;


namespace ScrumViewer.Pages
{
    public class CreateBacklogTaskModel : PageModel
    {
        [BindProperty]
        public Task Task { get; set; }

        public Models.StoryBoard StoryBoard { get; set; }
        public StoryBoardService StoryBoardService { get; private set; }

        public CreateBacklogTaskModel(StoryBoardService storyBoardService)
        {
            StoryBoardService = storyBoardService;
        }
        public void OnGet()
        {
            StoryBoard = StoryBoardService.GetStoryBoard();
        }

        public IActionResult OnPost()
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }
            StoryBoardService.AddCard(Task);
            return RedirectToPage("ProductBacklog");
        }
    }
}
