using System;
using System.Collections.Generic;
using System.Linq;

using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ScrumViewer.Models;

namespace ScrumViewer.Pages
{
    public class CreateSprintStoryTaskModel : PageModel
    {
        [BindProperty]
        public Task Task { get; set; }

        [BindProperty] public UserStory UserStory { get; set; }

        public Models.StoryBoard StoryBoard { get; set; }
        public StoryBoardService StoryBoardService { get; private set; }

        public CreateSprintStoryTaskModel(StoryBoardService storyBoardService)
        {
            StoryBoardService = storyBoardService;
        }
        public void OnGet(string id)
        {
            StoryBoard = StoryBoardService.GetStoryBoard();
            UserStory = (UserStory)StoryBoardService.GetUserStory(id);
        }

        public IActionResult OnPost(string id)
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }

            UserStory = (UserStory)StoryBoardService.GetUserStory(id);
            Task.UserStory = UserStory;
            Task.State = UserStory.State;
            StoryBoardService.AddCard(Task);
            return RedirectToPage("Index");
        }
    }
}
