using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ScrumViewer.Models;


namespace ScrumViewer.Pages
{
    public class CreateUserStoryModel : PageModel
    {
        [BindProperty]
        public UserStory UserStory { get; set; }

        public Models.StoryBoard StoryBoard { get; set; }
        public StoryBoardService StoryBoardService { get; private set; }

        public CreateUserStoryModel(StoryBoardService storyBoardService)
        {
            StoryBoardService = storyBoardService;
        }
        public void OnGet()
        {
            StoryBoard = StoryBoardService.GetStoryBoard();
        }

        public IActionResult OnPost()
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }
            StoryBoardService.AddCard(UserStory);
            return RedirectToPage("ProductBacklog");
        }
    }
}
