using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ScrumViewer.Models;


namespace StoryBoard.Pages
{
    public class StoryBoardModel : PageModel
    {
        private StoryBoardService storyBoardService;
        public ScrumViewer.Models.StoryBoard StoryBoard { get; private set; }


        public StoryBoardModel(StoryBoardService storyBoardService)
        {
            this.storyBoardService = storyBoardService;
        }
        public IActionResult OnGet()
        {
            StoryBoard = storyBoardService.GetStoryBoard();
            return Page();
        }

        public IActionResult OnGetMoveCard(string id)
        {
            storyBoardService.MoveUserStory(id);
            return RedirectToPage("Index");
        }

        public IActionResult OnGetRedoCard(string id)
        {
            storyBoardService.RedoUserStory(id);
            return RedirectToPage("Index");
        }
    }
}
