using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ScrumViewer.Models;


namespace ScrumViewer.Pages
{
    public class ProductBacklogModel : PageModel
    {
        private StoryBoardService storyBoardService;
        public Models.StoryBoard StoryBoard { get; private set; }


        public ProductBacklogModel(StoryBoardService storyBoardService)
        {
            this.storyBoardService = storyBoardService;
        }
        public IActionResult OnGet()
        {
            StoryBoard = storyBoardService.GetStoryBoard();
            return Page();
        }

        public IActionResult OnGetMoveCard(string id)
        {
            storyBoardService.MoveUserStory(id);
            return RedirectToPage("ProductBacklog");
        }
    }
}
