using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration.Xml;
using ScrumViewer.Models;


namespace ScrumViewer.Pages 
{ 
    public class UserStoryDetailsModel : PageModel
    {
        [BindProperty]
        public Card Card { get; set; }

        private StoryBoardService storyBoardService;
        public Models.StoryBoard StoryBoard { get; private set; }


        public UserStoryDetailsModel(StoryBoardService storyBoardService)
        {
            this.storyBoardService = storyBoardService;
        }
        public void OnGet(string id)
        {
            StoryBoard = storyBoardService.GetStoryBoard();
            Card = storyBoardService.GetUserStory(id);
        }

        public IActionResult OnGetMoveBackCard(string id)
        {
            storyBoardService.MoveBackUserStory(id);
            return RedirectToPage("Index");
        }
    }
}
